/////////////////////////////////////////////////////////////////////////////
//
// Copyright(C) 2002 Mitsuhiro Shirai
// E-mail shirai@as.email.ne.jp
//
// Last update	2002.12.10	SDKްޮ
//
// Calendar.h	CCalendar NX̐錾уC^[tF[X̒`܂D
// ̃NX̓J_[i{j{NXłD
//
//////////////////////////////////////////////////////////////////////////////

#pragma once 

#include <windows.h>
#include <stdio.h>

#include "DateEx.h"

// J_[̃ZIuWFNg
// LIST \̏ꍇ col ͂PɌŒ
typedef struct _CaCell  {
	INT	row;		// siPUs܂Łj
	INT	col;		// iPV܂Łj
	// lݒ
	void	SetCell(INT inLow,INT inCol)
			{row = inLow;col = inCol;};
	// L͈͂`FbNiRow̍ő͖`FbNj
	BOOL	isVarid()
	{return (row >= 1 && col >= 1 && col <= 7);};
	// ZIy[^
	_CaCell&	operator ++	(int)
			{col++;
			 if (col > 7)	{col = 1;row++;}
			 return *this;
			};
} _CA_CELL;

// NX`
class	CCalendar
{
public:

	// \`(̌`łPǗ)
	enum	{	TABLE = 0,		/* J_[`	*/
				LIST			/* \\`		*/
			};

	// TJ_[ł̍ő
	enum	{	LIST_MAX_DAYS = 35};

	// RXgN^EfXgN^
	CCalendar(INT inShowMode = TABLE,
			  INT inStartYoubi = CDateEx::SUN,
			  INT inYY = 0,
			  INT inMM = 0,
			  INT inDD = 0);
	virtual	~CCalendar();

	// o\bh

	LONG	StartJSerial()	const
				{return m_StartJSer;};					// JnJVA
	LONG	EndJSerial()	const
				{return (m_StartJSer + m_Days - 1);};	// IJVA
	void	FiratCell(_CA_CELL*	outCell)
				{*outCell = m_FirstCell;};				// JñZ
	INT	ShowMode()		const 
				{return m_ShowMode;};					// \[h
	INT	StartYoubi()	const
				{return m_StartYoubi;};					// Jnj

	// ŵiVA͔͈͓
	BOOL	isVaridJSerial(LONG	inJSer)
			{return ((inJSer >= m_StartJSer) && (inJSer < (m_StartJSer+m_Days)));};

	// `ύX̃\bh

	void	SwitchShowMode(
				LONG	inCurrentJSerial);	// \`XCb`

											// iinCurrentJSerial܂ނ悤Ɂj
	void	ChangeStartYoubi(
				INT	inStartYoubi);			// JnjύX

	// J_[̈ړ\bh

	void	Next();					// iLIST:Tj
	void	Back();					// OiLIST:OTj
	void	NextYear();				// N
	void	BackYear();				// ON
	void	TodayMonth();			// {̂錎
	BOOL	AppointMonth(
				INT	inYY,
				INT	inMM,
				INT	inDD = 1);		// w肵
	BOOL	AppointMonth(
				LONG inJSerial);	// w肵

	// ZvZp
	BOOL	JSerial2Cell(LONG		inJSerial,
						_CA_CELL*	outCell);		// iVAZ(TRUEj
	BOOL	Cell2JSerial(_CA_CELL	inCell,
						LONG*		outJSerial);	// iVAZ(TRUEj

	// J_[쐬TuNXǉ
	virtual void	MakeCalendarSelf();	
		// F
		// RXgN^ԐړIɌĂяoĂ邽߁Cnew Ƃ
		//  virtual ܂D
		// TuNX̃RXgN^ŌĂяo悤ɂĂD
		// iLQƁj
		// xIuWFNg쐬 vertual @\ɂ菟ɃTuNX
		//  MakeCalendarSelf Ăяo܂D
		// F
		// CSchCalendar::CSchCalendar(
		//		INT	inShowMode,
		//		INT	inStartYoubi,
		//		INT	inYY,
		//		INT	inMM,
		//		INT	inDD)
		//		:	CCalendar(inShowMode,inStartYoubi,inYY,inMM,inDD)
		// {
		//		MakeCalendarSelf();   	
		// }
	
protected:

	LONG	m_StartJSer;		// J_[̊Jn
	LONG	m_Days;				// Ǘ
	INT		m_ShowMode;			// \[h(TABLE or LIST)
	INT		m_StartYoubi;		// \Jn̗j
								// iTABLE ̏ꍇ͍[j
								// iLIST  ̏ꍇ͏lƂ Next Back ŕωj
	_CA_CELL	m_FirstCell;	// J_[JnZʒuiLIST ͏ɂPsPj

	void	MakeCalendar(
			CDateEx* inDate = NULL);	// J_[쐬


};