/////////////////////////////////////////////////////////////////////////////
//
// Copyright(C) 2002 Mitsuhiro Shirai
// E-mail shirai@as.email.ne.jp
//
// Last update	2002.12.10	SDKްޮ
//
// Calendar.h	CCalendar NX̓̒`܂D
// ̃NX̓J_[i{j{NXłD
//
//////////////////////////////////////////////////////////////////////////////

#include "Calendar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/*-------------------------------------------------------------------------*/
// CCalendar	NX̃RXgN^
/*-------------------------------------------------------------------------*/
CCalendar::CCalendar(
	INT	inShowMode,
	INT	inStartYoubi,
	INT	inYY,
	INT	inMM,
	INT	inDD)
{
	// NXϐ
	m_Days       = 0;
	m_StartJSer  = 0;
	m_ShowMode   = inShowMode;
	m_StartYoubi = inStartYoubi;

	// JnNݒiC[Kȏꍇ͓wj
	SYSTEMTIME	theSysTime;
	::GetSystemTime(&theSysTime);
	INT	theYY = inYY;
	INT	theMM = inMM;
	INT	theDD = inDD;
	if (inYY < 1)				theYY = theSysTime.wYear;
	if (inMM < 1 || inMM > 12)	theMM = theSysTime.wMonth;
	if (inDD < 1 || (inDD > CDateEx::LastDay(theYY,theMM)))	{
		theDD = theSysTime.wDay;
	}

	// J_[쐬
	CDateEx	theDate(theYY,theMM,theDD);
	MakeCalendar(&theDate);
}

/*-------------------------------------------------------------------------*/
// CCalendar	NX̃fXgN^
/*-------------------------------------------------------------------------*/
CCalendar::~CCalendar()
{
}


/*-------------------------------------------------------------------------*/
// MakeCalendar	J_[쐬								protected
/*-------------------------------------------------------------------------*/
void
CCalendar::MakeCalendar(
	CDateEx* inDate)
{
	// wLȏꍇ m_StartJSer vZ
	if (inDate)	{
		if (m_ShowMode == TABLE)	{
			// TABLE `͂P
			inDate->GotoFirstDay();
		}
		else	{
			// LIST `͎w܂ޏT
			while(inDate->youbi() != m_StartYoubi)	(*inDate)--;
		}
		m_StartJSer = inDate->JullanSerial();
	}

	// m_StartJSer JnƂJ_[쐬
	CDateEx	theDate(m_StartJSer);
	if (m_ShowMode == TABLE)	{
		// Ǘ̌P
		m_Days = theDate.thisLastDay();
		// JnZvZ(O[]`U[y]̊Ԃɂj
		INT	theStartYoubi = m_StartYoubi;
		INT	theRow = 1;
		INT	theCol = 1;
		while (theStartYoubi != theDate.youbi())	{
			theStartYoubi++;
			if (theStartYoubi >= 7)	theStartYoubi = 0;
			theCol++;
		}
		if (theCol == 1)	theRow++;		// 擪̏ꍇ͂Pi
		m_FirstCell.SetCell(theRow,theCol);
	}
	else	{
		// ǗőǗTԓ
		m_Days = LIST_MAX_DAYS;
		// JnZ͏ɐ擪
		m_FirstCell.SetCell(1,1);
	}

	// TuNXǉ
	MakeCalendarSelf();
}

/*-------------------------------------------------------------------------*/
// MakeCalendarSelf	J_[쐬TuNXǉ
/*-------------------------------------------------------------------------*/
void
CCalendar::MakeCalendarSelf()
{
	// ̓TuNXŒǉ镔
}

/*-------------------------------------------------------------------------*/
// SwitchShowMode	\`XCb`							public
/*-------------------------------------------------------------------------*/
void
CCalendar::SwitchShowMode(
	LONG	inCurrentJSerial)
{
	// ؂ւ
	m_ShowMode = (m_ShowMode == TABLE ? LIST : TABLE);

	// J_[ւ
	CDateEx	theDate(inCurrentJSerial);
	MakeCalendar(&theDate);
}

/*-------------------------------------------------------------------------*/
// ChangeStartYoubi	JnjύX								public
/*-------------------------------------------------------------------------*/
void
CCalendar::ChangeStartYoubi(
	INT	inStartYoubi)
{
	if ((inStartYoubi >= CDateEx::SUN) && 
		(inStartYoubi <= CDateEx::SAT))		{
		// JnjύX
		m_StartYoubi = inStartYoubi;
		if (m_ShowMode == LIST)	{
			// m_StartJSer 𒼑ȎΏۗjɖ߂
			CDateEx	theDate(m_StartJSer);
			while (theDate.youbi() != inStartYoubi)	theDate--;
			m_StartJSer = theDate.JullanSerial();
		}
		// J_[ւ
		MakeCalendar();
	}
}

/*-------------------------------------------------------------------------*/
// Next				iLIST:Tj							public
/*-------------------------------------------------------------------------*/
void
CCalendar::Next()
{
	// vZ
	CDateEx	theDate(m_StartJSer);
	if (m_ShowMode == TABLE)	{
		// i1ɂȂĂj
		theDate.DoNextMonth();
	}
	else	{
		// PTԐi߂
		theDate += 7;
	}
	// J_[ւ
	m_StartJSer = theDate.JullanSerial();
	MakeCalendar();
}

/*-------------------------------------------------------------------------*/
// Back				OiLIST:OTj							public
/*-------------------------------------------------------------------------*/
void
CCalendar::Back()
{
	// vZ
	CDateEx	theDate(m_StartJSer);
	if (m_ShowMode == TABLE)	{
		// Oi1ɂȂĂj
		theDate.DoBackMonth();
	}
	else	{
		// PTԖ߂
		theDate -= 7;
	}
	// J_[ւ
	m_StartJSer = theDate.JullanSerial();
	MakeCalendar();
}

/*-------------------------------------------------------------------------*/
// NextYear			N									public
/*-------------------------------------------------------------------------*/
void
CCalendar::NextYear()
{
	// vZ
	CDateEx	theDate(m_StartJSer);
	CDateEx	theNextYearDate((theDate.year() + 1),theDate.month(),theDate.day());
	// J_[ւ
	m_StartJSer = theNextYearDate.JullanSerial();
	MakeCalendar();
}

/*-------------------------------------------------------------------------*/
// BackYear			ON									public
/*-------------------------------------------------------------------------*/
void
CCalendar::BackYear()
{
	// vZ
	CDateEx	theDate(m_StartJSer);
	CDateEx	theNextYearDate((theDate.year() - 1),theDate.month(),theDate.day());
	// J_[ւ
	m_StartJSer = theNextYearDate.JullanSerial();
	MakeCalendar();
}

/*-------------------------------------------------------------------------*/
// TodayMonth		{̂錎								public
/*-------------------------------------------------------------------------*/
void
CCalendar::TodayMonth()
{
	// JnNݒ
	SYSTEMTIME	theSysTime;
	::GetSystemTime(&theSysTime);
	INT	theYY = theSysTime.wYear;
	INT	theMM = theSysTime.wMonth;
	INT	theDD = theSysTime.wDay;

	// J_[쐬
	CDateEx	theDate(theYY,theMM,theDD);
	MakeCalendar(&theDate);
}

/*-------------------------------------------------------------------------*/
// AppointMonth		w肵								public
/*-------------------------------------------------------------------------*/
BOOL
CCalendar::AppointMonth(
	INT	inYY,
	INT	inMM,
	INT	inDD)
{
	// JnNݒiC[Kȏꍇ͉Ȃj
	if ( (inYY < 1)					||
		 (inMM < 1 || inMM > 12)	||
		 (inDD < 1 || (inDD > CDateEx::LastDay(inYY,inMM))) )	return FALSE;

	// J_[쐬
	CDateEx	theDate(inYY,inMM,inDD);
	MakeCalendar(&theDate);
	return TRUE;
}

/*-------------------------------------------------------------------------*/
// AppointMonth		w肵								public
/*-------------------------------------------------------------------------*/
BOOL
CCalendar::AppointMonth(
	LONG	inJSerial)
{
	// JnNݒiC[Kȏꍇ͉Ȃj
	if (inJSerial < 0)	return FALSE;

	// J_[쐬
	CDateEx	theDate(inJSerial);
	MakeCalendar(&theDate);
	return TRUE;
}

/*-------------------------------------------------------------------------*/
// JSerial2Cell		iVAZ(TRUEj				public
/*-------------------------------------------------------------------------*/
BOOL
CCalendar::JSerial2Cell(
	LONG		inJSerial,
	_CA_CELL*	outCell)
{
	// ͈͂OĂꍇ FALSE 𕜋A
	BOOL	result = FALSE;
	if ((inJSerial >= m_StartJSer)		&&
		(inJSerial < (m_StartJSer + m_Days)) )	{
		// Jnt̑ΈʒuiO`j߂
		INT	theCount = INT(inJSerial - m_StartJSer);
		// Cell ̈ʒuvZ
		if (m_ShowMode == TABLE)	{
			*outCell = m_FirstCell;
			for (INT i=0;i<theCount;i++)	(*outCell)++;
		}
		else	{
			outCell->SetCell(theCount+1,1);
		}
		result = TRUE;
	}
	return result;
}

/*-------------------------------------------------------------------------*/
// Cell2JSerial		ZiVA(TRUEj				public
/*-------------------------------------------------------------------------*/
BOOL
CCalendar::Cell2JSerial(
	_CA_CELL	inCell,
	LONG*		outJSerial)
{
	// ͈͂OĂꍇ FALSE 𕜋A
	BOOL	result = FALSE;
	if (inCell.isVarid())	{
		_CA_CELL	theCell = inCell;
		INT		theCols =7;
		if (m_ShowMode == LIST)	{
			theCell.col = 1;
			theCols		= 1;
		}
		// [ォ̑ΈʒuiO`j߂
		INT	theCount = (theCell.row - 1) * theCols + (theCell.col - 1);
		// ZJnʒuZ
		theCount -=  (m_FirstCell.row - 1) * theCols + (m_FirstCell.col - 1);
		// JVAvZ
		LONG	theJSerial = m_StartJSer + theCount;
		if ((theJSerial >= m_StartJSer)		&&
			(theJSerial < (m_StartJSer + m_Days)) )	{
			*outJSerial = theJSerial;
			result = TRUE;
		}
	}
	return result;
}

